## tellico 4.0.1

=== CMakeLists.txt ===
# FindPoppler requires CMake >= 3.16
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)

project(Tellico)
set(TELLICO_VERSION "4.0.1")

if(DEFINED BUILD_WITH_QT6)
  set(GLOBAL_BUILD_WITH_QT6 ${BUILD_WITH_QT6})
endif()

find_package(ECM REQUIRED NO_MODULE)
# ECM uses the required version to determine whether to build with Qt6
# Instead, use the installed version and assume building with Qt6 unless
# BUILD_WITH_QT6=OFF was passed to cmake
if(NOT DEFINED GLOBAL_BUILD_WITH_QT6 AND
   ECM_VERSION VERSION_GREATER_EQUAL 5.240)
  option(BUILD_WITH_QT6 "Build against Qt 6" ON)
endif()

if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif(POLICY CMP0063)

if(QT_MAJOR_VERSION STREQUAL "6")
  set(QT_MIN_VERSION "6.4.0")
  set(KF_MIN_VERSION "5.240.0")
  set(CMAKE_CXX_STANDARD 20)
else()
  set(QT_MIN_VERSION "5.12.0")
  set(KF_MIN_VERSION "5.72.0")
  set(CMAKE_CXX_STANDARD 17)
endif()

# https://gitlab.kitware.com/cmake/community/wikis/doc/cmake/Useful-Variables
# automatically add CMAKE_CURRENT_SOURCE_DIR and CMAKE_CURRENT_BINARY_DIR
# to the include directories in every processed CMakeLists.txt
set(CMAKE_INCLUDE_CURRENT_DIR TRUE)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
                      ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules
                      ${ECM_MODULE_PATH})

include(ECMAddAppIcon)
include(ECMUninstallTarget)
include(FeatureSummary)

include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)
set(CMAKE_C_EXTENSIONS OFF)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)

############# Options #################

option(ENABLE_CDTEXT       "Enable cdtext" TRUE)
option(ENABLE_WEBCAM       "Enable support for webcams" FALSE)
option(BUILD_FETCHER_TESTS "Build tests which verify data sources" FALSE)
option(USE_KHTML           "Build with KHTML rather than QWebEngine" FALSE)
option(ENABLE_BTPARSE      "Build with bibtex importing using btparse, whether internal or external" TRUE)

# btparse does not compile with msvc
if(ENABLE_BTPARSE AND MSVC)
  set(ENABLE_BTPARSE FALSE)
endif()

include(CheckSymbolExists)
check_symbol_exists(strlwr "string.h" HAVE_STRLWR)
check_symbol_exists(strupr "string.h" HAVE_STRUPR)

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Widgets
    Xml
    DBus
    Test
    Network
    PrintSupport
)

set(KF_MAJOR_VERSION ${QT_MAJOR_VERSION})
find_package(KF${KF_MAJOR_VERSION} REQUIRED COMPONENTS
    Archive
    Codecs
    Completion
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DocTools
    GuiAddons
    IconThemes
    ItemModels
    I18n
    JobWidgets
    KIO
    Solid
    Sonnet
    TextWidgets
    WidgetsAddons
    XmlGui
)

if(NOT USE_KHTML)
  find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} CONFIG OPTIONAL_COMPONENTS
    WebEngineWidgets
  )
  set_package_properties(Qt${QT_MAJOR_VERSION}WebEngineWidgets PROPERTIES
    DESCRIPTION "Building with QWebEngine is preferrable to KHTML"
    TYPE OPTIONAL)
endif()
if(USE_KHTML OR NOT Qt${QT_MAJOR_VERSION}WebEngineWidgets_FOUND)
  set(USE_KHTML ON)
  find_package(KF${KF_MAJOR_VERSION}KHtml REQUIRED NO_MODULE)
  set_package_properties(KF${KF_MAJOR_VERSION}Html PROPERTIES
    DESCRIPTION "Building with QWebEngine is preferrable to KHTML")
endif()

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} CONFIG OPTIONAL_COMPONENTS
  Charts
)

include(MacroBoolTo01)

find_package(Gettext REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(LibXslt REQUIRED)

find_package(KF${KF_MAJOR_VERSION}FileMetaData)
set_package_properties(KF${KF_MAJOR_VERSION}FileMetaData PROPERTIES
    DESCRIPTION "Support for reading file metadata"
    URL "https://www.kde.org"
    TYPE OPTIONAL)

find_package(KF${KF_MAJOR_VERSION}NewStuff)
set_package_properties(KF${KF_MAJOR_VERSION}NewStuff PROPERTIES
    DESCRIPTION "Support for fetching new templates and scripts"
    URL "https://www.kde.org"
    TYPE OPTIONAL)

if (KF_MAJOR_VERSION STREQUAL "5")
    set(KSANE_TARGET_NAME KF5::Sane)
    find_package(KF5Sane)
else()
    set(KSANE_TARGET_NAME KSaneWidgets6)
    find_package(KSaneWidgets6)
endif()
set_package_properties(KSANE_TARGET_NAME PROPERTIES
    DESCRIPTION "Support for adding scanned images to a collection"
    URL "https://www.kde.org"
    TYPE OPTIONAL)

if (KF_MAJOR_VERSION STREQUAL "5")
    set(KCDDB_TARGET_NAME KF5::Cddb)
    find_package(KF5Cddb 5.1)
else()
    set(KCDDB_TARGET_NAME KCddb6)
    find_package(KCddb6 5.1)
endif()
set_package_properties(${KCDDB_TARGET_NAME} PROPERTIES
    DESCRIPTION "Support for CDDB searches"
    URL "https://invent.kde.org/multimedia/libkcddb"
    TYPE OPTIONAL)

find_package(Taglib)
if(TAGLIB_FOUND)
    if(TAGLIB_LIBRARIES)
        # Older taglib
        add_definitions(${TAGLIB_CFLAGS})
        include_directories(${TAGLIB_INCLUDES})
    else()
        set(TAGLIB_LIBRARIES Taglib::Taglib)
    endif()
endif(TAGLIB_FOUND)

find_package(Yaz 2.0)
set_package_properties(Yaz PROPERTIES
    DESCRIPTION "Support for searching z39.50 databases"
    URL "https://www.indexdata.com/resources/software/yaz/"
    TYPE OPTIONAL)
if(Yaz_FOUND)
    include_directories(${Yaz_INCLUDE_DIRS})
endif(Yaz_FOUND)

# FindPoppler is part of ECM >= 5.19
find_package(Poppler COMPONENTS Qt${QT_MAJOR_VERSION})

find_package(Exempi 2.0)
set_package_properties(Exempi PROPERTIES
    DESCRIPTION "Support for reading PDF/XMP metadata"
    URL "https://libopenraw.freedesktop.org/exempi/"
    TYPE OPTIONAL)
if(Exempi_FOUND)
    include_directories(${Exempi_INCLUDE_DIRS})
endif(Exempi_FOUND)

if(ENABLE_BTPARSE)
find_package(Btparse)
set_package_properties(Btparse PROPERTIES
    DESCRIPTION "External support for parsing and processing BibTeX data files"
    URL "https://metacpan.org/release/Text-BibTeX"
    TYPE OPTIONAL)
if(Btparse_FOUND)
    include_directories(${Btparse_INCLUDE_DIRS})
    set(TELLICO_BTPARSE_LIBS ${Btparse_LIBRARIES})
else(Btparse_FOUND)
    set(TELLICO_BTPARSE_LIBS btparse-tellico)
endif(Btparse_FOUND)
endif(ENABLE_BTPARSE)

find_package(CDIO)
set_package_properties(CDIO PROPERTIES
    DESCRIPTION "Support for reading cdtext from audio CDs"
    URL "https://www.gnu.org/software/libcdio/"
    TYPE OPTIONAL)
if(CDIO_FOUND)
    include_directories(${CDIO_INCLUDE_DIRS})
endif(CDIO_FOUND)

find_package(Csv 3.0)
set_package_properties(Csv PROPERTIES
    DESCRIPTION "External support for reading CSV files"
    URL "http://sourceforge.net/projects/libcsv/"
    TYPE OPTIONAL)
if(Csv_FOUND)
    include_directories(${Csv_INCLUDE_DIRS})
    set(TELLICO_CSV_LIBS ${Csv_LIBRARIES})
else(Csv_FOUND)
    set(TELLICO_CSV_LIBS csv-tellico)
endif(Csv_FOUND)

# webcam uses libv4l, which only works on Linux for now
# Linux 2.6.38 removed the videodev.h header
# libv4l 0.8.3 includes a compat header for videodev.h
if(ENABLE_WEBCAM)
    if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
        message("WARNING: Webcam support is not available on your platform")
        set( ENABLE_WEBCAM FALSE )
    else(NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
        pkg_check_modules(LIBV4L libv4l1>=0.6)
        #macro_log_feature(LIBV4L_FOUND "libv4l" "Support for barcode scanning with a webcam" "https://hansdegoede.livejournal.com/3636.html"  FALSE "" "")
        set_package_properties(LIBV4L PROPERTIES
            DESCRIPTION "Support for barcode scanning with a webcam"
            URL "https://hansdegoede.livejournal.com/3636.html"
            TYPE OPTIONAL)
        if(LIBV4L_FOUND)
            if(LIBV4L_VERSION VERSION_LESS "0.8.3" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "2.6.37")
                message("WARNING: libv4l 0.8.3 or later is required for Linux kernel 2.6.38 or later")
                set( ENABLE_WEBCAM FALSE )
            else(LIBV4L_VERSION VERSION_LESS "0.8.3" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "2.6.37")
                include_directories(${LIBV4L_INCLUDE_DIR})
            endif(LIBV4L_VERSION VERSION_LESS "0.8.3" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "2.6.37")
        else(LIBV4L_FOUND)
            set(ENABLE_WEBCAM FALSE)
        endif(LIBV4L_FOUND)
    endif(NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
endif(ENABLE_WEBCAM)

if(CMAKE_COMPILER_IS_GNUCXX)
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -Wextra -fno-check-new -Woverloaded-virtual")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -fno-check-new -Woverloaded-virtual -Wno-deprecated -Wno-deprecated-declarations")
endif(CMAKE_COMPILER_IS_GNUCXX)

add_definitions(-DQT_STL -DQT_NO_CAST_FROM_ASCII -DQT_NO_URL_CAST_FROM_STRING -DQT_USE_QSTRINGBUILDER)
remove_definitions(-DQT_NO_STL)

include_directories(${LIBXML2_INCLUDE_DIR}
                    ${LIBXSLT_INCLUDE_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${Tellico_SOURCE_DIR}/src/config
                    ${Tellico_SOURCE_DIR}/src/3rdparty)

set(TELLICO_DATA_INSTALL_DIR ${KDE_INSTALL_DATADIR}/tellico)

add_subdirectory(src)
add_subdirectory(icons)
add_subdirectory(xslt)
add_subdirectory(doc)

########## Wrap tests results around the tests done within the source

macro_bool_to_01(TAGLIB_FOUND HAVE_TAGLIB)
macro_bool_to_01(Poppler_Qt${QT_MAJOR_VERSION}_FOUND HAVE_POPPLER)
macro_bool_to_01(Exempi_FOUND HAVE_EXEMPI)
macro_bool_to_01(Yaz_FOUND HAVE_YAZ)
macro_bool_to_01(${KSANE_TARGET_NAME}_FOUND HAVE_KSANE)
macro_bool_to_01(Libkcddb_FOUND HAVE_OLD_KCDDB)
macro_bool_to_01(${KCDDB_TARGET_NAME}_FOUND HAVE_KCDDB)
macro_bool_to_01(KDEPIMLIBS_FOUND HAVE_KABC)
macro_bool_to_01(KDEPIMLIBS_FOUND HAVE_KCAL)
macro_bool_to_01(LIBV4L_FOUND HAVE_V4L)
macro_bool_to_01(KF${KF_MAJOR_VERSION}NewStuff_FOUND ENABLE_KNEWSTUFF3)
macro_bool_to_01(Btparse_FOUND HAVE_LIBBTPARSE)
macro_bool_to_01(CDIO_FOUND HAVE_CDIO)
macro_bool_to_01(Csv_FOUND HAVE_LIBCSV)
macro_bool_to_01(KF${KF_MAJOR_VERSION}FileMetaData_FOUND HAVE_KFILEMETADATA)
macro_bool_to_01(Qt${QT_MAJOR_VERSION}Charts_FOUND HAVE_QCHARTS)
macro_bool_to_01(ENABLE_BTPARSE ENABLE_BTPARSE)
macro_bool_to_01(BUILD_FETCHER_TESTS ENABLE_NETWORK_TESTS)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

########### install files ###############

install(PROGRAMS org.kde.tellico.desktop DESTINATION ${KDE_INSTALL_APPDIR})
install(FILES tellico.xml DESTINATION  ${KDE_INSTALL_MIMEDIR})
install(FILES org.kde.tellico.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} )
ki18n_install(po)
kdoctools_install(po)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/cite/CMakeLists.txt ===
SET(cite_STAT_SRCS
   lyxpipe.cpp
   actionmanager.cpp
   clipboard.cpp
   )

add_library(cite STATIC ${cite_STAT_SRCS})

target_link_libraries(cite
    core
    utils
    config
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Widgets
)

ADD_DEPENDENCIES(cite tellico_config)

=== src/commands/CMakeLists.txt ===
########### next target ###############

SET(commands_STAT_SRCS
   addentries.cpp
   modifyentries.cpp
   removeentries.cpp
   addloans.cpp
   modifyloans.cpp
   removeloans.cpp
   fieldcommand.cpp
   filtercommand.cpp
   reorderfields.cpp
   collectioncommand.cpp
   renamecollection.cpp
   updateentries.cpp
)

add_library(commands STATIC ${commands_STAT_SRCS})

target_link_libraries(commands
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Widgets
    KF${KF_MAJOR_VERSION}::I18n
)

=== src/fetch/CMakeLists.txt ===
ADD_SUBDIRECTORY( scripts )

########### next target ###############

SET(fetch_STAT_SRCS
   adsfetcher.cpp
   amazonfetcher.cpp
   amazonrequest.cpp
   arxivfetcher.cpp
   bedethequefetcher.cpp
   bibliosharefetcher.cpp
   bibsonomyfetcher.cpp
   boardgamegeekfetcher.cpp
   colnectfetcher.cpp
   comicvinefetcher.cpp
   configwidget.cpp
   crossreffetcher.cpp
   dbcfetcher.cpp
   dblpfetcher.cpp
   discogsfetcher.cpp
   doubanfetcher.cpp
   dvdfrfetcher.cpp
   entrezfetcher.cpp
   execexternalfetcher.cpp
   fetcher.cpp
   fetcherinfolistitem.cpp
   fetcherinitializer.cpp
   fetcherjob.cpp
   fetchmanager.cpp
   fetchrequest.cpp
   fetchresult.cpp
   filmaffinityfetcher.cpp
   filmasterfetcher.cpp
   gaminghistoryfetcher.cpp
   gcstarpluginfetcher.cpp
   gcstarthread.cpp
   giantbombfetcher.cpp
   googlebookfetcher.cpp
   googlescholarfetcher.cpp
   hathitrustfetcher.cpp
   ibsfetcher.cpp
   igdbfetcher.cpp
   imdbfetcher.cpp
   imdbfetcher_query.cpp
   isbndbfetcher.cpp
   itunesfetcher.cpp
   kinofetcher.cpp
   kinopoiskfetcher.cpp
   kinoteatrfetcher.cpp
   messagehandler.cpp
   messagelogger.cpp
   mobygamesfetcher.cpp
   moviemeterfetcher.cpp
   mrlookupfetcher.cpp
   multifetcher.cpp
   musicbrainzfetcher.cpp
   numistafetcher.cpp
   omdbfetcher.cpp
   opdsfetcher.cpp
   openlibraryfetcher.cpp
   rpggeekfetcher.cpp
   springerfetcher.cpp
   srufetcher.cpp
   thegamesdbfetcher.cpp
   themoviedbfetcher.cpp
   thetvdbfetcher.cpp
   tvmazefetcher.cpp
   upcitemdbfetcher.cpp
   vgcollectfetcher.cpp
   videogamegeekfetcher.cpp
   vndbfetcher.cpp
   xmlfetcher.cpp
   z3950connection.cpp
   z3950fetcher.cpp
   )

add_library(fetch STATIC ${fetch_STAT_SRCS})

TARGET_LINK_LIBRARIES(fetch
    newstuff
    utils
    ${TELLICO_BTPARSE_LIBS}
    Qt${QT_MAJOR_VERSION}::Network
    KF${KF_MAJOR_VERSION}::Archive
    KF${KF_MAJOR_VERSION}::IconThemes
    KF${KF_MAJOR_VERSION}::JobWidgets
    KF${KF_MAJOR_VERSION}::KIOWidgets
    KF${KF_MAJOR_VERSION}::ConfigWidgets
    KF${KF_MAJOR_VERSION}::KIOGui
    )

IF( Yaz_FOUND )
  TARGET_LINK_LIBRARIES(fetch ${Yaz_LIBRARIES})
ENDIF( Yaz_FOUND )

########### install files ###############

INSTALL(FILES z3950-servers.cfg DESTINATION ${TELLICO_DATA_INSTALL_DIR} )

=== src/gui/CMakeLists.txt ===
########### next target ###############

SET(gui_STAT_SRCS
   boolfieldwidget.cpp
   checkablecombobox.cpp
   choicefieldwidget.cpp
   collectiontemplatedialog.cpp
   collectiontypecombo.cpp
   combobox.cpp
   countdelegate.cpp
   datefieldwidget.cpp
   datewidget.cpp
   detailedentryitemdelegate.cpp
   dockwidget.cpp
   drophandler.cpp
   imagefieldwidget.cpp
   imagewidget.cpp
   fieldwidget.cpp
   fieldwidgetfactory.cpp
   filterrulewidget.cpp
   filterrulewidgetlister.cpp
   kwidgetlister.cpp
   lineedit.cpp
   linefieldwidget.cpp
   listwidgetitem.cpp
   numberfieldwidget.cpp
   parafieldwidget.cpp
   previewdialog.cpp
   progress.cpp
   ratingdelegate.cpp
   ratingfieldwidget.cpp
   ratingwidget.cpp
   spinbox.cpp
   starrating.cpp
   statusbar.cpp
   stringmapdialog.cpp
   stringmapwidget.cpp
   tablefieldwidget.cpp
   tabwidget.cpp
   treeview.cpp
   urlfieldwidget.cpp
)

SET(gui_UI
  collectiontemplatedialog.ui
)
qt_wrap_ui(gui_STAT_SRCS ${gui_UI})

add_library(gui STATIC ${gui_STAT_SRCS})

TARGET_LINK_LIBRARIES(gui
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Widgets
    Qt${QT_MAJOR_VERSION}::Gui
    KF${KF_MAJOR_VERSION}::KIOCore
    KF${KF_MAJOR_VERSION}::KIOFileWidgets
    KF${KF_MAJOR_VERSION}::SonnetCore
    KF${KF_MAJOR_VERSION}::SonnetUi
    KF${KF_MAJOR_VERSION}::XmlGui
    KF${KF_MAJOR_VERSION}::I18n
    KF${KF_MAJOR_VERSION}::TextWidgets
    KF${KF_MAJOR_VERSION}::IconThemes
)
IF(QT_MAJOR_VERSION STREQUAL "6")
  TARGET_LINK_LIBRARIES(gui KF${KF_MAJOR_VERSION}::IconWidgets)
ENDIF()

IF(USE_KHTML)
  TARGET_LINK_LIBRARIES(gui KF${KF_MAJOR_VERSION}::KHtml)
  ADD_DEFINITIONS(-DUSE_KHTML=${USE_KHTML})
ELSE()
  TARGET_LINK_LIBRARIES(gui Qt${QT_MAJOR_VERSION}::WebEngineWidgets)
ENDIF()

IF( ${KSANE_TARGET_NAME}_FOUND )
  TARGET_LINK_LIBRARIES(gui ${KSANE_TARGET_NAME})
ENDIF( ${KSANE_TARGET_NAME}_FOUND )

=== src/images/CMakeLists.txt ===
SET(images_STAT_SRCS
   image.cpp
   imagedirectory.cpp
   imagefactory.cpp
   imageinfo.cpp
   imagejob.cpp
   )

add_library(images STATIC ${images_STAT_SRCS})

TARGET_LINK_LIBRARIES(images
    core
    config
    utils
    KF${KF_MAJOR_VERSION}::KIOCore
    KF${KF_MAJOR_VERSION}::Archive
    KF${KF_MAJOR_VERSION}::GuiAddons
    Qt${QT_MAJOR_VERSION}::Gui
)

ADD_DEPENDENCIES(images tellico_config)

=== src/models/CMakeLists.txt ===
########### next target ###############

SET(models_STAT_SRCS
   abstractsortmodel.cpp
   borrowermodel.cpp
   entrygroupmodel.cpp
   entryiconmodel.cpp
   entrymodel.cpp
   entryselectionmodel.cpp
   entrysortmodel.cpp
   fieldcomparison.cpp
   filtermodel.cpp
   groupsortmodel.cpp
   modeliterator.cpp
   modelmanager.cpp
   stringcomparison.cpp
)

add_library(tellicomodels STATIC ${models_STAT_SRCS})

target_link_libraries(tellicomodels
    core
    images
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::Widgets
    KF${KF_MAJOR_VERSION}::ItemModels
)

ADD_DEPENDENCIES(tellicomodels tellico_config)

=== src/translators/CMakeLists.txt ===
########### next target ###############

SET(translators_STAT_SRCS
   adsimporter.cpp
   alexandriaexporter.cpp
   alexandriaimporter.cpp
   amcimporter.cpp
   audiofileimporter.cpp
   bibtexexporter.cpp
   bibteximporter.cpp
   bibtexmlexporter.cpp
   bibtexmlimporter.cpp
   boardgamegeekimporter.cpp
   ciwimporter.cpp
   collectorzimporter.cpp
   csvexporter.cpp
   csvimporter.cpp
   csvparser.cpp
   datacrowimporter.cpp
   dataimporter.cpp
   deliciousimporter.cpp
   discogsimporter.cpp
   ebookimporter.cpp
   exporter.cpp
   filelistingimporter.cpp
   filereader.cpp
   filereaderbook.cpp
   filereadervideo.cpp
   freedb_util.cpp
   freedbimporter.cpp
   gcstarexporter.cpp
   gcstarimporter.cpp
   goodreadsimporter.cpp
   griffithimporter.cpp
   grs1importer.cpp
   htmlexporter.cpp
   importer.cpp
   librarythingimporter.cpp
   marcimporter.cpp
   onixexporter.cpp
   pdfimporter.cpp
   referencerimporter.cpp
   risimporter.cpp
   tellico_xml.cpp
   tellicoimporter.cpp
   tellicoxmlexporter.cpp
   tellicoxmlreader.cpp
   tellicozipexporter.cpp
   textimporter.cpp
   vinoxmlimporter.cpp
   xmlstatehandler.cpp
   xmphandler.cpp
   xsltexporter.cpp
   xslthandler.cpp
   xsltimporter.cpp
   )

add_library(translators STATIC ${translators_STAT_SRCS})
TARGET_LINK_LIBRARIES(translators
    collections
    tellicomodels
    core
    gui
    images
    utils
    ${TELLICO_BTPARSE_LIBS}
    ${TELLICO_CSV_LIBS}
    rtf2html-tellico
    )

TARGET_LINK_LIBRARIES(translators
    KF${KF_MAJOR_VERSION}::Archive
    KF${KF_MAJOR_VERSION}::JobWidgets
    KF${KF_MAJOR_VERSION}::Solid
    ${LIBXML2_LIBRARIES}
    ${LIBXSLT_LIBRARIES}
    ${LIBXSLT_EXSLT_LIBRARIES}
    )

IF( ${KCDDB_TARGET_NAME}_FOUND )
  TARGET_LINK_LIBRARIES(translators ${KCDDB_TARGET_NAME})
ELSEIF( Libkcddb_FOUND )
  TARGET_LINK_LIBRARIES(translators KDE::Libkcddb::kcddb)
ENDIF( ${KCDDB_TARGET_NAME}_FOUND)

IF( Poppler_Qt${QT_MAJOR_VERSION}_FOUND )
  TARGET_LINK_LIBRARIES(translators Poppler::Qt${QT_MAJOR_VERSION})
ENDIF( Poppler_Qt${QT_MAJOR_VERSION}_FOUND )

IF( KF${KF_MAJOR_VERSION}FileMetaData_FOUND )
  TARGET_LINK_LIBRARIES(translators KF${KF_MAJOR_VERSION}::FileMetaData)
ENDIF( KF${KF_MAJOR_VERSION}FileMetaData_FOUND )

IF( Exempi_FOUND )
  TARGET_LINK_LIBRARIES(translators ${Exempi_LIBRARIES})
ENDIF( Exempi_FOUND )

IF( TAGLIB_FOUND )
  TARGET_LINK_LIBRARIES(translators ${TAGLIB_LIBRARIES})
ENDIF( TAGLIB_FOUND )

IF( CDIO_FOUND )
  TARGET_LINK_LIBRARIES(translators ${CDIO_LIBRARIES})
ENDIF( CDIO_FOUND )

ADD_DEPENDENCIES(translators tellico_config)

########### install files ###############

INSTALL(FILES bibtex-translation.xml DESTINATION ${TELLICO_DATA_INSTALL_DIR})

=== src/utils/CMakeLists.txt ===
########### next target ###############

SET(utils_STAT_SRCS
   bibtexhandler.cpp
   cursorsaver.cpp
   datafileregistry.cpp
   gradient.cpp
   guiproxy.cpp
   iso5426converter.cpp
   iso6937converter.cpp
   isbnvalidator.cpp
   lccnvalidator.cpp
   mergeconflictresolver.cpp
   string_utils.cpp
   tellico_utils.cpp
   upcvalidator.cpp
   urlfieldlogic.cpp
   xmlhandler.cpp
   )

add_library(utils STATIC ${utils_STAT_SRCS})

TARGET_LINK_LIBRARIES(utils
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Widgets
    Qt${QT_MAJOR_VERSION}::Xml
    KF${KF_MAJOR_VERSION}::CoreAddons # for KRandom
    KF${KF_MAJOR_VERSION}::I18n
    KF${KF_MAJOR_VERSION}::WidgetsAddons
    KF${KF_MAJOR_VERSION}::Codecs
    KF${KF_MAJOR_VERSION}::KIOCore
)

=== src/3rdparty/rtf2html/CMakeLists.txt ===

########### next target ###############

SET(rtf2html_STAT_SRCS
   fmt_opts.cpp
   rtf2html.cpp
   rtf_keyword.cpp
   rtf_table.cpp
   )

ADD_LIBRARY(rtf2html-tellico STATIC ${rtf2html_STAT_SRCS})

target_link_libraries(rtf2html-tellico
    Qt${QT_MAJOR_VERSION}::Core
)

=== src/fetch/scripts/CMakeLists.txt ===

########### install files ###############

SET(SCRIPT_FILES
    dark_horse_comics.py
    )

SET(SPEC_FILES
    dark_horse_comics.py.spec
    )

INSTALL(PROGRAMS ${SCRIPT_FILES} DESTINATION ${TELLICO_DATA_INSTALL_DIR}/data-sources )

INSTALL(FILES ${SPEC_FILES} DESTINATION ${TELLICO_DATA_INSTALL_DIR}/data-sources )

=== debian/changelog ===
tellico (4.0.1-4) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Update watch file.

  [ Boyuan Yang ]
  * debian/control: Use build-dependency package name from taglib 2.x.
    (libtag1-dev => libtag-dev)
  * Rebuild against taglib 2.0.2.

 -- Boyuan Yang <byang@debian.org>  Sun, 12 Jan 2025 20:32:22 -0500

tellico (4.0.1-2) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Use new mailing list email in Maintainers field.
  * Build against Qt6, update build-deps and deps with the info from cmake.
  * Add patch to skip failing filelisting test.
  * Drop reproducible=-fixfilepath build option, builds are now made in
    a fixed location.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 29 Dec 2024 13:24:34 +0100

tellico (4.0.1-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Wed, 02 Oct 2024 19:22:11 +0200

tellico (4.0-2) unstable; urgency=medium

  * Fold tellico-scripts into tellico-data: the idea for the split was to add
    the possibility to update the scripts separately using the old
    debian-volatile concept (see 1.3.1-2); since there are less and less scripts
    and configuration files (resp. 1 and 1), and the vast majority of the
    collectors are implemented in native code, then the separate update of
    tellico-scripts is of practically no use anymore
    - install all the data files in tellico-data, simplifying its install file
    - add the breaks/replaces in tellico-data for the file move
    - turn tellico-scripts into an empty package; it does not need to depend on
      tellico-data, as the latter is already a dependency of tellico
    - drop the tellico-scripts dependency in tellico
  * Simplify the handling of the temporary directories when invoking
    dh_auto_test:
    - stop manually creating/passing $HOME and $XDG_RUNTIME_DIR, as debhelper
      handles them already in compat 13
    - use a static "tmp" subdirectory of the local "test_root" as $TMPDIR,
      so it is already cleaned, and it does not pollute the system $TMPDIR
  * Prepare tellico for the future switch to Qt 6, which means also WebEngine
    as mandatory (since KHTML is dead, and no more available in KF6):
    - restrict the architecture to amd64 arm64 armhf i386, i.e. the
      architectures on which Qt6 WebEngine is available
    - remove the architecture restriction from the qtwebengine5-dev build
      dependency
    - drop the libkf5khtml-dev build dependency, no more needed now

 -- Pino Toscano <pino@debian.org>  Wed, 25 Sep 2024 20:18:17 +0200

=== debian/control ===
Source: tellico
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-python,
               breeze-icon-theme <!nocheck>,
               cmake (>= 3.16~),
               dbus <!nocheck>,
               extra-cmake-modules,
               gettext,
               kio <!nocheck>,
               libbtparse-dev,
               libcdio-dev,
               libcsv-dev,
               libexempi-dev,
               libkf6archive-dev (>= 5.240.0~),
               libkf6codecs-dev (>= 5.240.0~),
               libkf6completion-dev (>= 5.240.0~),
               libkf6config-dev (>= 5.240.0~),
               libkf6configwidgets-dev (>= 5.240.0~),
               libkf6coreaddons-dev (>= 5.240.0~),
               libkf6crash-dev (>= 5.240.0~),
               libkf6doctools-dev (>= 5.240.0~),
               libkf6filemetadata-dev (>= 5.240.0~),
               libkf6guiaddons-dev (>= 5.240.0~),
               libkf6i18n-dev (>= 5.240.0~),
               libkf6iconthemes-dev (>= 5.240.0~),
               libkf6itemmodels-dev (>= 5.240.0~),
               libkf6jobwidgets-dev (>= 5.240.0~),
               libkf6kio-dev (>= 5.240.0~),
               libkf6newstuff-dev (>= 5.240.0~),
               libkf6solid-dev (>= 5.240.0~),
               libkf6sonnet-dev (>= 5.240.0~),
               libkf6textwidgets-dev (>= 5.240.0~),
               libkf6widgetsaddons-dev (>= 5.240.0~),
               libkf6xmlgui-dev (>= 5.240.0~),
               libkcddb6-dev,
               libksane-dev,
               libpoppler-qt6-dev [!i386],
               libtag-dev,
               libxml2-dev,
               libxslt1-dev,
               libyaz-dev,
               pkg-kde-tools,
               pkgconf,
               python3:any,
               qt6-base-dev (>= 6.4.0~),
               qt6-charts-dev (>= 6.4.0~),
               qt6-webengine-dev (>= 6.4.0~),
               tidy <!nocheck>,
               xauth <!nocheck>,
               xvfb <!nocheck>,
               yaz <!nocheck>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://tellico-project.org/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/tellico
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/tellico.git

Package: tellico
Architecture: amd64 arm64 armhf i386
Depends: tellico-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends},
Recommends: kio-extras, tellico-doc,
Description: Collection manager for books, videos, music, etc
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.

Package: tellico-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
Recommends: khelpcenter, tellico,
Description: Collection manager for books, videos, music, etc [doc]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the documentation.

Package: tellico-data
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}, ${python3:Depends},
Recommends: tellico,
Breaks: tellico-scripts (<< 4.0-2~),
Replaces: tellico-scripts (<< 4.0-2~),
Description: Collection manager for books, videos, music, etc [data]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the architecture independent files, such data files and
 documentation.

Package: tellico-scripts
Section: oldlibs
Architecture: all
Depends: ${misc:Depends},
Description: transitional package for tellico-data
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 This is a transitional package for the move of the scripts to tellico-data,
 so it can be safely uninstalled.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# do not use kdeinit for kio
export KDE_FORK_SLAVES=1

%:
	dh $@ --with kf6,python3

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-* && $(MAKE) install DESTDIR=$(CURDIR)/test_root
	mkdir -p "$(CURDIR)/test_root/tmp"
	xvfb-run -a --server-args="-screen 0 1024x768x24+32" dbus-run-session dh_auto_test --no-parallel -- XDG_DATA_DIRS=$(CURDIR)/test_root/usr/share:/usr/local/share:/usr/share TMPDIR="$(CURDIR)/test_root/tmp"
endif

execute_after_dh_auto_install:
	# extra copyright notices
	rm -fv debian/tmp/usr/share/tellico/pics/README.*

override_dh_python3:
	dh_python3 -p tellico-data --shebang=/usr/bin/python3 /usr/share/tellico/data-sources

## tellico 4.0.1+r3.5.4

=== debian/changelog ===
tellico (4.0.1+r3.5.4-1ubuntu3) plucky; urgency=medium

  * No-change rebuild for taglib.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 13 Jan 2025 17:01:59 +0000

tellico (4.0.1+r3.5.4-1ubuntu2) plucky; urgency=medium

  * Build without cddb support for now.

 -- Rik Mills <rikmills@kde.org>  Fri, 08 Nov 2024 16:06:35 +0000

tellico (3.5.4-1ubuntu4) oracular; urgency=medium

  * Properly address the apparmor profile issue by adding multiple
    lines for the different architectures we want to support until 
    @multiarch is supported. This closes (LP: #2064492)

 -- Scarlett Moore <sgmoore@debian.org>  Mon, 02 Sep 2024 07:04:20 -0700

=== debian/control ===
Source: tellico
Section: kde
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 13),
 , dh-apparmor
 , cmake (>= 3.16~), extra-cmake-modules (>= 5.19.0~)
 , pkg-config, pkg-kde-tools, qtbase5-dev (>= 5.10.0~),
 , libqt5charts5-dev (>= 5.10.0~),
 , qtwebengine5-dev (>= 5.10.0~) [amd64 arm64 armhf i386],
 , libkf5archive-dev
# , libkf5cddb-dev
 , libkf5codecs-dev
 , libkf5config-dev
 , libkf5configwidgets-dev
 , libkf5coreaddons-dev
 , libkf5crash-dev
 , libkf5doctools-dev
 , libkf5filemetadata-dev
 , libkf5guiaddons-dev
 , libkf5khtml-dev
 , libkf5i18n-dev
 , libkf5iconthemes-dev
 , libkf5itemmodels-dev
 , libkf5jobwidgets-dev
 , libkf5kio-dev
 , libkf5newstuff-dev
# , libkf5sane-dev
 , libkf5solid-dev
 , libkf5sonnet-dev
 , libkf5textwidgets-dev
 , libkf5wallet-dev
 , libkf5widgetsaddons-dev
 , libkf5xmlgui-dev
 , libtag1-dev, libyaz-dev, libpoppler-qt5-dev
 , libexempi-dev, libcsv-dev, libbtparse-dev
 , libcdio-dev
 , gettext
 , xvfb <!nocheck>, xauth <!nocheck>, kio <!nocheck>, yaz <!nocheck>
 , python3:any, dh-python
 , dbus <!nocheck>
 , tidy <!nocheck>
# missing in libtag1-dev
 , zlib1g-dev
# missing in libkf5sane-dev
 , libksanecore-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://tellico-project.org/
Vcs-Browser: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/tellico
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/tellico.git

Package: tellico
Architecture: any
Depends: tellico-data (= ${source:Version})
 , tellico-scripts (>= ${source:Version})
 , ${shlibs:Depends}, ${misc:Depends}
Recommends: tellico-doc, kio-extras
Suggests: apparmor
Description: Collection manager for books, videos, music, etc
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.

Package: tellico-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: tellico, khelpcenter
Description: Collection manager for books, videos, music, etc [doc]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the documentation.

Package: tellico-data
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}
Recommends: tellico
Description: Collection manager for books, videos, music, etc [data]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the architecture independent files, such data files and
 documentation.

Package: tellico-scripts
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Recommends: tellico
Description: Collection manager for books, videos, music, etc [scripts]
 Tellico is a collection manager for KDE. It includes default collections for
 books, bibliographies, comic books, videos, music, coins, stamps, trading
 cards, and wines.
 .
 Tellico capabilities include:
 .
   * creation of user-defined custom collections with unlimited fields,
   * automatically formatted names,
   * sorting and filtering by any field or property,
   * ISBN validation,
   * full customization for printing or display through XSLT files,
   * import and export of CSV, RIS, BibTeX and BibTeXML files,
   * import data from Amazon, IMDb, CDDB or any US-MARC compliant z39.50 server.
 .
 Tellico files are stored in XML format, avoiding the need for a database
 server, and allowing other software applications to use the data.
 .
 This package contains the scripts to import data from external sources, such
 as websites. As the format of the data may change, these scripts are provided
 as a separate package which can be updated through debian-volatile.
